;***************************************************************************
;*
;* "Auswertung" + "Senden USB"
;*
;* This subroutine generates the required Data from Lin Frames for
;* transmitting. outside
;* 
;*
;***************************************************************************

;**** Sendeanfordertung ist da ********************************************************

auswert:
		cli
		push	TEMP_0
		push	TEMP_1

		cbr		FLAGS,(1<<LRX)
		ldi		YL,LOW(RXBuffer)
		ldi		YH,HIGH(RXBuffer)		; Zeiger auf Buffer
		ld		TEMP_1,Y+			; Paketnummer
		ld		TEMP_1,Y+			;
		ld		TEMP_1,Y+			;
		ld		TEMP_1,Y			; Regen & Helligkeit
		ld		TEMP_0,Y			; sichern
		andi	TEMP_0,0x0F			; Helligkeit isolieren
;==================================================================
; Routine fr einfachen gleitenden Mittelwert (Licht)
;------------------------------------------------------------------
		
		mov		LICHT_3,LICHT_2
		mov		LICHT_2,LICHT_1
		mov		LICHT_1,TEMP_0

 		add 	LICHT,LICHT_3     	; neue Werte zu den alten addieren
		add 	LICHT,LICHT_2
		add 	LICHT,LICHT_1

		lsr		LICHT				; durch 2 teilen
		lsr		LICHT				; durch 2 teilen

		swap	TEMP_1
		andi	TEMP_1,0x0F			; Regenwert isolieren
;==================================================================
; Routine fr einfachen gleitenden Mittelwert  (Regen)
;------------------------------------------------------------------
		
 		mov		REGEN_3,REGEN_2
		mov		REGEN_2,REGEN_1
		mov		REGEN_1,TEMP_1
		
		add 	REGEN,REGEN_1      	; neuen Wert addieren
		add 	REGEN,REGEN_2      	; neuen Wert addieren
		add 	REGEN,REGEN_3      	; neuen Wert addieren
 		
		lsr		REGEN				; durch 2 teilen
		lsr		REGEN				; durch 2 teilen
		
		pop		TEMP_1
		pop		TEMP_0
		sei
		ret


senden:
		cli
		push TEMP_0

		cbr		FLAGS,(1<<FLAG_RX_OK)
		
		load_p	X,RX_BUF					; Empfangsbuffer Startadresse
		ld		TEMP_0,X+					; Kommando in Temp_0
		andi	TEMP_0, 0x0F
		
		cpi		TEMP_0, 0x01				; Kommando 1 -> Rckmeldung Licht					;	
		breq	kommando_1	

		cpi		TEMP_0, 0x02
		breq	kommando_2					; Kommando 2 -> Rckmeldung Regen

		cpi 	TEMP_0, 0x03					
		breq 	kommando_3					; Kommando 3 -> Version etc. auslesen
		
		pop		TEMP_0
		sei
		ret
kommando_1:
		mov		TEMP_0, LICHT
		rcall	uart_send_byte_hex

		pop		TEMP_0
		sei
		ret

kommando_2:
		mov		TEMP_0, REGEN
		rcall	uart_send_byte_hex

		pop		TEMP_0
		sei
		ret

kommando_3: ;Versionsabfrage

		load_p	Z,(2*text_start_1)
		rcall	uart_send_text
		load_p	Z,(2*text_start_2)
		rcall	uart_send_text
		load_p	Z,(2*text_ok)
		rcall	uart_send_text
		pop		TEMP_0
		sei
		ret



.include "tabellen.inc"
.include "uart.inc"
